import 'package:flutter/foundation.dart';
import 'package:graphql_flutter/graphql_flutter.dart';
import 'dart:async';

class AdeptGraphQLClient extends GraphQLClient
{
  Duration timeout;
  AdeptGraphQLClient({
    @required Link link,
    @required Cache cache,
    DefaultPolicies defaultPolicies,
    this.timeout
  }) : super(
    link: link,
    cache: cache,
    defaultPolicies: defaultPolicies,
  );

  @override
  Future<QueryResult> query(QueryOptions options) {
    var response = super.query(options);
    return timeout != null ? response.timeout(timeout) : response;
  }

  @override
  Future<QueryResult> mutate(MutationOptions options) {
    var response = super.mutate(options);
    return timeout != null ? response.timeout(timeout) : response;
  }

//  @override
//  Stream<FetchResult> subscribe(Operation operation) {
//    var response = super.subscribe(operation);
//    return timeout != null ? response.timeout(timeout) : response;
//  }
}