import 'dart:async';
export 'package:adeptarch/src/dao/super_room.dart';

abstract class SuperDao<T>
{
  Future<int> insert({T data, List<T> dataList}) async => 0;
  Future<int> update({T data, List<T> dataList}) async => 0;
  Future<int> delete({T data, List<T> dataList}) async => 0;
  T load() => null;
  Future<T> loadAsync() async => load();
  void save({T data, List<T> dataList}){}
  void clear(){}
}
