import 'package:flutter/material.dart';
import 'package:adeptarch/src/filters/filters.dart';
import 'package:flutter/services.dart';
import 'dart:async';

class FilterController<T extends Filter> extends ValueNotifier<T> {
  String _error;

  FilterController({T filter}) : super(filter);

  bool get hasError => error != null;

  String get error => _error;

  set error(String value) {
    _error = value;
    _feedback();
  }

  void _feedback() async{
    for(int i = 0; i < 3; ++i)
      await Future.delayed(Duration(milliseconds: 100), () => HapticFeedback.vibrate());
  }

  void clearError() => _error = null;

  void reset(){
    clearError();
    if(value != null) {
      value.reset();
      notifyListeners();
    }
  }

  void clear() {
    clearError();
    if(value != null) {
      value.clear();
      notifyListeners();
    }
  }
}