import 'package:adeptarch/src/resource/resource.dart';
import 'package:adeptarch/src/utils/adept_publish_subject.dart';
import 'dart:async';

abstract class ResourceDataAccess<ResourceData, Data, Param>
{
  Data loadSync({dynamic params});
  Future<Data> loadAsync({dynamic params});
  AdeptPublishSubject<Resource<ResourceData>> load({List<Param> params});
  AdeptPublishSubject<Resource<ResourceData>> loadNew({List<Param> params});
  void save({Data data, List<Data> dataList, bool updateRef});
  void delete({Data data, List<Data> dataList, bool updateRef});
  void clear({bool updateRef, AdeptPublishSubject<Resource<ResourceData>> publishSubject});
  void notifyChanges();
}
