/// Status of a resource that is provided to the UI.
/// <p>
/// These are usually created by the Repository classes where they return
/// {@code LiveData<Resource<T>>} to pass back the latest liveData to the UI with its fetch status.
enum ResourceStatus
{
  SUCCESS, //specifies the resource is successfully loaded
  ERROR, //specifies there was an error loading the resource
  LOADING, //specifies the resource is loading
  TRANSIENT, //specifies the resource is in a undefined transitory state
}
